Index: /trunk/kernel/fs/fatfs.h
===================================================================
--- /trunk/kernel/fs/fatfs.h	(revision 656)
+++ /trunk/kernel/fs/fatfs.h	(revision 657)
@@ -2,6 +2,5 @@
  * fatfs.h - FATFS file system API definition.
  *
- * Author    Mohamed Lamine Karaoui (2014,2015)
- *           Alain Greiner (2016,2017,2018)
+ * Author    Alain Greiner (2016,2017,2018,2019,2020)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -27,5 +26,5 @@
 
 #include <hal_kernel_types.h>
-#include <remote_queuelock.h>
+#include <remote_rwlock.h>
 #include <vfs.h>
 #include <dev_ioc.h>
@@ -36,14 +35,12 @@
  *
  * The FATFS specific extensions to the generic VFS are the following:
- * 1) The vfs_ctx_t "extend" field is a void* pointing on the fatfs_ctx_t structure.
- *    This structure contains various general informations such as the total
- *    number of sectors in FAT region, the number of bytes per sector, the number 
- *    of sectors per cluster, the lba of FAT region, the lba of data region, or the
- *    cluster index for the root directory. It contains also an extended pointer
- *    on the FAT mapper.
+ * 1) The vfs_ctx_t "extend" field contains a local pointer on the local 
+ *    fatfs_ctx_t structure.
+ *
  * 2) The vfs_inode_t "extend" contains, for each inode,
- *    the first FAT32 cluster_id (after cast to intptr).
- * 3) The vfs_dentry_t "extend" field contains, for each dentry, the entry index
- *    in the FATFS directory (32 bytes per FATFS directory entry).
+ *    the first FATFS cluster_id (after cast to intptr).
+ *
+ * 3) The vfs_dentry_t "extend" field contains a local pointer on the local
+ *    FATFS directory entry (32 bytes) in the directory mapper.
  *
  * In the FAT32 File System, the File Allocation Table is is actually an array 
@@ -57,6 +54,4 @@
  *****************************************************************************************/
  
-///////////////////////////////////////////////////////////////////////////////////////////
-
 /*************** Partition Boot Sector Format **********************************/
 //                                     offset |  length
@@ -182,4 +177,8 @@
  * This structure defines a FATFS specific context extension to the VFS context.
  * This fatfs context is replicated in all clusters.
+ * It contains read-only informations such as the total number of sectors in FAT region,
+ * the number of bytes per sector, the number of sectors per cluster, the lba of FAT,
+ * the lba of data region, the cluster_id for the root directory, and an extended 
+ * pointer on the FAT mapper.
  *
  * WARNING 1 : All access to the FAT are protected by a remote_rwlock. 
@@ -189,9 +188,9 @@
  *   functions to modify the FAT in both the FAT mapper and on IOC device.
  *
- * WARNING 2 : Most fields are constant values, but the <free_cluster_hint>,
- * <free_clusters>, <lock>, and the <fs_info_buffer> are shared variables, 
- * that can be modified by any thread running in any cluster. The <fs_info_buffer> 
- * contains a copy of the FS_INFO sector, and is only allocated in the FAT cluster 
- * (cluster 0). It is used to synchronously update the free clusters info on IOC device.
+ * WARNING 2 : Most fields are constant values, but <free_cluster_hint>, <free_clusters>,
+ * <lock>, and the buffer pointed by the <fs_info_xp> are shared variables, that can
+ * modified by any thread running in any cluster. The <fs_info_buffer>  contains
+ * a copy of the FS_INFO sector, and is only allocated in the FAT cluster. 
+ * It is used to synchronously update the free clusters info on IOC device.
  *  => For all these variables, only the values stored in the FAT cluster must be used.
  ****************************************************************************************/
@@ -207,9 +206,9 @@
     uint32_t            fs_info_lba;           /*! lba of FS_INFO sector                */
     uint32_t            root_dir_cluster;      /*! cluster index for  root directory    */
-    xptr_t              fat_mapper_xp;         /*! extended pointer on FAT mapper       */
+    struct mapper_s   * fat_mapper;            /*! local pointer on FAT mapper          */
 
     /* shared variables (only the copy in FAT cluster must be used)                     */
-    uint32_t            free_cluster_hint;     /*! cluster[hint+1] is the first free    */
-    uint32_t            free_clusters;         /*! free clusters number                 */
+    uint32_t            free_cluster_hint;     /*! free_cluster_hint + 1 is first free  */
+    uint32_t            free_clusters;         /*! number of free clusters              */
     remote_rwlock_t     lock;                  /*! exclusive access to FAT              */
     uint8_t           * fs_info_buffer;        /*! local pointer on FS_INFO buffer      */
@@ -224,5 +223,5 @@
  * This debug function display the content of the FATFS context copy in cluster
  * identified by the <cxy> argument.
- * This function can be called by a thread running in any cluster.
+ * This function can be called by any thread running in any cluster.
  *****************************************************************************************
  * @ cxy       :  target cluster identifier.
@@ -232,16 +231,27 @@
 /*****************************************************************************************
  * This debug function access the FAT mapper to display the current FAT state,
- * as defined by the <page_id>, <min_slot>, and <nb_slots> arguments.
- * It loads the missing pages from IOC to mapper if required.
- * This function can be called by a thread running in any cluster.
- *****************************************************************************************
- * @ page_id   : page index in FAT mapper (one page is 4 Kbytes = 1024 slots).
- * @ min_slot  : first slot in page
- * @ nb_slots  : number of slots (one slot is 4 bytes).
- ****************************************************************************************/
-void fatfs_display_fat( uint32_t  page_id,
-                        uint32_t  min_slot,
+ * as defined by the <min_slot>, and <nb_slots> arguments.
+ * It display as many lines (8 slots par line) as required to display <nb_slots>,
+ * starting from the <min_slot>. The displayed slots can spread on several FAT mapper
+ * pages. It loads the missing pages from IOC to mapper if required.
+ * This function can be called by any thread running in any cluster.
+ *****************************************************************************************
+ * @ min_slot   : first FATFS cluster index.
+ * @ nb_slots   : number of slots (one slot is 4 bytes.
+ ****************************************************************************************/
+void fatfs_display_fat( uint32_t  min_slot,
                         uint32_t  nb_slots );
 
+/*****************************************************************************************
+ * This function checks the current values of the "free_clusters" and "free_cluster_hint" 
+ * variables in the FS_INFO sector on IOC, versus the values stored in the fatfs context.
+ * As these values are synchronously updated on IOC device at each modification, 
+ * it does nothing if the values are equal. It updates the FS_INFO sector on IOC device,
+ * and displays a warning message on TXT0 if they are not equal.
+ * This function can be called by any thread running in any cluster. 
+ *****************************************************************************************
+ * @ return 0 if success / return -1 if failure during IOC device access.
+ ****************************************************************************************/
+error_t fatfs_check_free_info( void );
 
 //////////////////////////////////////////////////////////////////////////////////////////
@@ -251,33 +261,41 @@
 
 /*****************************************************************************************
- * This fuction allocates memory from local cluster for a FATFS context descriptor.
- *****************************************************************************************
- * @ return a pointer on the created context / return NULL if failure.
- ****************************************************************************************/
-fatfs_ctx_t * fatfs_ctx_alloc( void );
-
-/*****************************************************************************************
- * This function access the boot device, and initialises the local FATFS context,
- * from informations contained in the boot record. This initialisation includes the
- * creation of the FAT mapper in cluster 0.
- *****************************************************************************************
- * @ vfs_ctx   : local pointer on VFS context for FATFS.
- ****************************************************************************************/
-void fatfs_ctx_init( fatfs_ctx_t * fatfs_ctx );
-
-/*****************************************************************************************
- * This function releases memory dynamically allocated for the FATFS context extension.
- *****************************************************************************************
- * @ vfs_ctx   : local pointer on VFS context.
- ****************************************************************************************/
-void fatfs_ctx_destroy( fatfs_ctx_t * fatfs_ctx );
+ * This fuction allocates memory for a FATFS context descriptor in a cluster
+ * identified by the <cxy> argument.
+ *****************************************************************************************
+ * @ cxy   : target cluster identifier.
+ * @ return an extended pointer on the created context / return XPTR_NULL if failure.
+ ****************************************************************************************/
+xptr_t  fatfs_ctx_alloc( cxy_t  cxy );
+
+/*****************************************************************************************
+ * This fuction initialize a fatfs context identified by the <fatfs_ctx_xp> argument
+ * from informations found in the IOC device boot record. This initialisation includes
+ * allocation of the FS_INFO buffer and creation of the FAT mapper in the same cluster.
+ *****************************************************************************************
+ * @ fatfs_ctx_xp   : extended pointer on fatfs context.
+ * @ return 0 if success / return -1 if failure.
+ ****************************************************************************************/
+error_t  fatfs_ctx_init( xptr_t  fatfs_ctx_xp );
+
+/*****************************************************************************************
+ * This function releases memory dynamically allocated for the FATFS context.
+ *****************************************************************************************
+ * @ vfs_ctx_xp   : extended pointer on FATFS context.
+ ****************************************************************************************/
+void fatfs_ctx_destroy( xptr_t  fatfs_ctx_xp );
 
 /*****************************************************************************************
  * This function implements the generic vfs_fs_add_dentry() function for the FATFS.
  *****************************************************************************************
- * This function updates a directory mapper identified by the <inode> argument
- * to add a new directory entry identified by the <dentry> argument.
+ * This function introduces in a directory mapper identified by the <parent_inode_xp>
+ * argument a new directory entry identified by the <dentry_ptr> argument.
+ * The dentry descriptor and the associated inode descriptor must have been previously
+ * allocated, initialized, and registered in the Inode Tree. 
+ * The dentry descriptor defines the "name" field.
+ * The inode descriptor defines the "type", "size", and "cluster_id" fields.
+ * The "extension field" in dentry descriptor is set : index in the FAT32 directory.
  * All modified pages in the directory mapper are synchronously updated on IOC device.
- * It must be called by a thread running in the cluster containing the directory inode.
+ * This function can be called by any thread running in any cluster.
  *
  * Implementation note : this function works in two steps:
@@ -285,22 +303,22 @@
  *   to find the end of directory (NO_MORE_ENTRY marker).
  * - Then it writes 3, 4, or 5 directory entries (depending on the name length), using 
- *   a 5 steps FSM (one state per entry to be written), updates on IOC device the 
- *   modified pages, and updates the dentry extension field, that must contain 
- *   the dentry index in FATFS directory.
- *****************************************************************************************
- * @ inode    : local pointer on directory inode.
- * @ dentry   : local pointer on dentry.
- * @ return 0 if success / return ENOENT if not found, or EIO if no access to IOC device.
- ****************************************************************************************/
-error_t fatfs_add_dentry( struct vfs_inode_s  * inode,
-                          struct vfs_dentry_s * dentry );
+ *   a 5 steps FSM (one state per entry to be written), and updates on IOC device the 
+ *   modified pages.
+ *****************************************************************************************
+ * @ parent_inode_xp : [in]  extended pointer on parent directory inode.
+ * @ dentry_ptr      : [in]  local pointer on dentry (in parent directory cluster).
+ * @ index           : [out] index of the new entry in the FAT32 directory.
+ * @ return 0 if success / return -1 if failure.
+ ****************************************************************************************/
+error_t fatfs_add_dentry( xptr_t                parent_inode_xp,
+                          struct vfs_dentry_s * dentry_ptr );
 
 /*****************************************************************************************
  * This function implements the generic vfs_fs_remove_dentry() function for the FATFS.
  *****************************************************************************************
- * This function updates a directory identified by the <inode> argument
- * to remove a directory entry identified by the <dentry> argument.
+ * This function updates a directory identified by the <parent_inode_xp> argument
+ * to remove a directory entry identified by the <dentry_ptr> argument.
  * All modified pages in directory mapper are synchronously updated on IOC device.
- * It must be called by a thread running in the cluster containing the inode.
+ * This function can be called by any thread running in any cluster.
  *
  * Implementation note: this function uses the dentry extension to directly access 
@@ -308,50 +326,72 @@
  * updates the modified pages on IOC device.
  *****************************************************************************************
- * @ inode    : local pointer on directory inode.
- * @ dentry   : local pointer on dentry.
- * @ return 0 if success / return ENOENT if not found, or EIO if no access to IOC device.
- ****************************************************************************************/
-error_t fatfs_remove_dentry( struct vfs_inode_s  * inode,
-                             struct vfs_dentry_s * dentry );
-
-/*****************************************************************************************
- * This function implements the generic vfs_fs_new_dentry() function for the FATFS.
- *****************************************************************************************
- * It scan a parent directory mapper, identified by the <parent_inode> argument to find
- * a directory entry identified by the <name> argument.  In case of success, it completes
- * initialization the inode/dentry couple, identified by the  <child_inode_xp> argument.
- * The child inode descriptor, and the associated dentry descriptor must have been
- * previously allocated by the caller.
+ * @ parent_inode_xp   : [in] extended pointer on parent directory inode.
+ * @ dentry_ptr        : [in] local pointer on dentry (in parent directory cluster).
+ * @ return 0 if success / return -1 if failure.
+ ****************************************************************************************/
+error_t fatfs_remove_dentry( xptr_t                parent_inode_xp,
+                             struct vfs_dentry_s * dentry_ptr );
+
+/*****************************************************************************************
+ * This function implements the generic vfs_fs_new_dentry_from_mapper() for the FATFS.
+ *****************************************************************************************
+ * It scan a parent directory mapper, identified by the <parent_inode_xp> argument 
+ * to find a directory entry name defined by the <dentry_ptr> argument, and completes
+ * the initialization of the dentry and the associated child_inode descriptors,
+ * from informations found in the parent directory mapper :
  * - It set the "type", "size", and "extend" fields in the child inode descriptor.
  * - It set the " extend" field in the dentry descriptor.
- * It must be called by a thread running in the cluster containing the parent inode.
- *****************************************************************************************
- * @ parent_inode    : local pointer on parent inode (directory).
- * @ name            : child name.
- * @ child_inode_xp  : extended pointer on remote child inode (file or directory).
+ * The child inode descriptor, and the dentry descriptor must have been previously
+ * allocated and introduced in the Inode Tree.
+ * This function can be called by any thread running in any cluster.
+ *****************************************************************************************
+ * @ parent_inode_xp : extended pointer on parent inode (directory).
+ * @ dentry_ptr      : local pointer on new dentry (in parent inode cluster).
+ * @ return 0 if success / return -1 if failure.
+ ****************************************************************************************/
+error_t fatfs_new_dentry_from_mapper( xptr_t                parent_inode_xp,
+                                      struct vfs_dentry_s * dentry_ptr );
+
+/*****************************************************************************************
+ * This function implements the generic vfs_fs_new_dentry_to_mapper() for the FATFS.
+ *****************************************************************************************
+ * This function  introduces a brand new dentry identified by the <dentry_ptr> argument
+ * in the mapper of a directory identified by the <parent_inode_xp> argument.
+ * It is called by the vfs_lookup() function.
+ * The child inode descriptor, and the dentry descriptor must have been previously
+ * allocated and introduced in the Inode Tree. The dentry descriptor contains the name.
+ * 1. It allocates a new FATFS cluster_id,
+ * 2. It registers the allocated cluster_id in the child inode extension,
+ * 3. It add a new entry (32 bytes) in the directory mapper,
+ * This function can be called by any thread running in any cluster.
+ *****************************************************************************************
+ * @ parent_inode_xp : [in]  extended pointer on parent inode (directory).
+ * @ dentry_ptr      : [in]  local pointer on dentry (in parent inode cluster).
+ * @ return 0 if success / return -1 if failure.
+ ****************************************************************************************/
+error_t fatfs_new_dentry_to_mapper( xptr_t                parent_inode_xp,
+                                    struct vfs_dentry_s * dentry_ptr );
+
+/*****************************************************************************************
+ * This function implements the generic vfs_fs_update_dentry() function for the FATFS.
+ *****************************************************************************************
+ * It update the "size" of a directory entry identified by the <dentry_ptr> argument in
+ * the mapper of a directory identified by the <parent_inode_xp> argument, from the
+ * value registered in the inode descriptor.
+ * It scan the directory mapper to find the entry such as name == dentry_ptr->name.
+ * It set the "size" field in the directory mapper, and updates the modified directory
+ * page on the IOC device.
+ * This function can be called by any thread running in any cluster.
+ *
+ * TODO the current implementation uses the fatfs_scan_directory to access the 
+ * FAT32 directory by name. We can access directly this directory entry if we use
+ * the dentry "extend" field...
+ *****************************************************************************************
+ * @ parent_inode_xp : extended pointer on inode (directory).
+ * @ dentry_ptr      : local pointer on dentry (in parent directory cluster).
  * @ return 0 if success / return -1 if child not found.
  ****************************************************************************************/
-error_t fatfs_new_dentry( struct vfs_inode_s * parent_inode,
-                          char               * name,
-                          xptr_t               child_inode_xp );
-
-/*****************************************************************************************
- * This function implements the generic vfs_fs_update_dentry() function for the FATFS.
- *****************************************************************************************
- * It update the size of a directory entry identified by the <dentry> argument in
- * the mapper of a directory identified by the <inode> argument, as defined by the
- * <size> argument.
- * It scan the mapper to find the entry identified by the dentry "name" field.
- * It set the "size" field in the in the directory mapper AND marks the page as DIRTY.
- * It must be called by a thread running in the cluster containing the directory inode.
- *****************************************************************************************
- * @ inode        : local pointer on inode (directory).
- * @ dentry       : local pointer on dentry (for name).
- * @ size         : new size value.
- * @ return 0 if success / return ENOENT if child not found.
- ****************************************************************************************/
-error_t fatfs_update_dentry( struct vfs_inode_s  * inode,
-                             struct vfs_dentry_s * dentry,
-                             uint32_t              size );
+error_t fatfs_update_dentry( xptr_t                parent_inode_xp,
+                             struct vfs_dentry_s * dentry_ptr );
 
 /*****************************************************************************************
@@ -367,7 +407,9 @@
  * the Inode Tree is dynamically created, and all dirent fields are documented in the
  * dirent array. Otherwise, only the dentry name is documented.
- * It must be called by a thread running in the cluster containing the directory inode.
- *****************************************************************************************
- * @ inode      : [in]  local pointer on directory inode.
+ *
+ * WARNING : It must be called by a thread running in the cluster containing the
+ * target directory inode.
+ *****************************************************************************************
+ * @ parent_inode_xp  : [in]  extended pointer on directory inode.
  * @ array      : [in]  local pointer on array of dirents.
  * @ max_dirent : [in]  max number of slots in dirent array.
@@ -390,14 +432,15 @@
  *****************************************************************************************
  * It updates the FATFS on the IOC device for a given inode identified by 
- * the <inode> argument. It scan all pages registered in the associated mapper,
+ * the <inode_xp> argument. It scan all pages registered in the associated mapper,
  * and copies from mapper to device each page marked as dirty.
  * WARNING : The target <inode> cannot be a directory, because all modifications in a 
  * directory are synchronously done on the IOC device by the two fatfs_add_dentry() 
  * and fatfs_remove_dentry() functions.
- *****************************************************************************************
- * @ inode   : local pointer on inode.
- * @ return 0 if success / return -1 if failure during IOC device access. 
- ****************************************************************************************/
-error_t fatfs_sync_inode( struct vfs_inode_s * inode );
+ * This function can be called by any thread running in any cluster.
+ *****************************************************************************************
+ * @ inode_xp   : extended pointer on inode.
+ * @ return 0 if success / return -1 if failure. 
+ ****************************************************************************************/
+error_t fatfs_sync_inode( xptr_t  inode_xp );
 
 /*****************************************************************************************
@@ -407,9 +450,8 @@
  * It scan all clusters registered in the FAT mapper, and copies from mapper to device 
  * each page marked as dirty.
- *
- * TODO : the current implementation check ALL pages in the FAT region, even if most
- * pages are empty, and not copied in mapper. It is sub-optimal.
- * A solution is to maintain in the FAT context two "dirty_min" and "dirty_max"
- * variables defining the smallest/largest dirty page index in FAT mapper... 
+ * This function can be called by any thread running in any cluster. 
+ *
+ * Implementation note : this function uses the grdxt_remote_get_first() function
+ * to test only the pages actually registered in the FAT mapper.
  *****************************************************************************************
  * @ return 0 if success / return -1 if failure during IOC device access.
@@ -418,41 +460,7 @@
 
 /*****************************************************************************************
- * This function implements the generic vfs_fs_sync_fsinfo() function for the FATFS.
- *****************************************************************************************
- * It checks the current values of the "free_clusters" and "free_cluster_hint" variables
- * in the FS_INFO sector on IOC, versus the values stored in the fatfs context.
- * As these values are synchronously updated on IOC device at each modification, 
- * it does nothing if the values are equal. It updates the FS_INFO sector on IOC device,
- * and displays a warning message on TXT0 if they are not equal.
- * This function can be called by any thread running in any cluster. 
- *****************************************************************************************
- * @ return 0 if success / return -1 if failure during IOC device access.
- ****************************************************************************************/
-error_t fatfs_sync_free_info( void );
-
-/*****************************************************************************************
- * This function implements the generic vfs_fs_cluster_alloc() function for the FATFS.
- *****************************************************************************************
- * It access the FAT (File allocation table), stored in the FAT mapper, and returns
- * in <searched_cluster> the FATFS cluster index of a free cluster.
- * It can be called by a thread running in any cluster, as it uses remote access
- * primitives when the FAT mapper is remote. It takes the rwlock stored in the FATFS
- * context located in the same cluster as the FAT mapper itself, to get exclusive
- * access to the FAT. It uses and updates the <free_cluster_hint> and <free_clusters>
- * variables stored in this FATFS context.
- * - it updates the <free_cluster_hint> and <free_clusters> variables in FATFS context.
- * - it updates the FAT mapper (handling miss from IOC device if required). 
- * - it synchronously updates the FAT region on IOC device. 
- * - it returns the allocated cluster index.
- *****************************************************************************************
- * @ searched_cluster_id  : [out] allocated FATFS cluster index.
- * @ return 0 if success / return -1 if no more free clusters on IOC device.
- ****************************************************************************************/
-error_t fatfs_cluster_alloc( uint32_t * searched_cluster_id );
-
-/*****************************************************************************************
  * This function implements the generic vfs_fs_release_inode() function for the FATFS.
  *****************************************************************************************
- * This function is used to remove a given file or directory from FATFS the file system.
+ * This function is used to remove a given file or directory from the FATFS file system.
  * It releases all clusters allocated to a file/directory identified by the <inode_xp>
  * argument. All released clusters are marked FREE_CLUSTER in the FAT mapper. 
@@ -462,4 +470,5 @@
  * synchronously update all modified pages in the FAT mapper to the IOC device.
  * Finally the FS-INFO sector on the IOC device is updated.
+ * This function can be called by any thread running in any cluster.
  *****************************************************************************************
  * @ inode_xp   : extended pointer on inode.
@@ -478,15 +487,8 @@
  * - For a regular file, it scan the FAT mapper to get the cluster_id on IOC device,
  *   and read/write this cluster.
- * It can be called by any thread running in any cluster.
+ * This function can be called by any thread running in any cluster.
  *
  * WARNING : For the FAT mapper, the inode field in the mapper MUST be NULL, as this
  *           is used to indicate that the corresponding mapper is the FAT mapper.
- *
- * TODO : In this first implementation, the entry point in the FAT to get the cluster_id
- *        is always the cluster_id of the first page, registered in the inode extension.
- *        This can introduce a quadratic cost when trying of acessing all pages of a
- *        big file. An optimisation would be to introduce in the inode extension two
- *        new fields <other_page_id> & <other_cluster_id>, defining a second entry point
- *        in the FAT.
  *****************************************************************************************
  * @ page_xp   : extended pointer on page descriptor.
@@ -494,6 +496,6 @@
  * @ return 0 if success / return EIO if error during device access. 
  ****************************************************************************************/
-error_t fatfs_move_page( xptr_t      page_xp,
-                         cmd_type_t  cmd_type );
+error_t fatfs_move_page( xptr_t          page_xp,
+                         ioc_cmd_type_t  cmd_type );
 
 
Index: /trunk/kernel/fs/ramfs.h
===================================================================
--- /trunk/kernel/fs/ramfs.h	(revision 656)
+++ /trunk/kernel/fs/ramfs.h	(revision 657)
@@ -3,5 +3,5 @@
  *
  * Authors   Mohamed Lamine Karaoui (2014,2015)
- *           Alain Greiner (2016,2017)
+ *           Alain Greiner (2016,2017,2018,2019,2020)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -29,5 +29,4 @@
 // The RAMFS File System does not uses any external device to store data.
 // It stores the dynamically created files and directories in the VFS mappers.
-// The ramfs_read_page() and ramfs_write_page() functions should never be used.
 // The RAMFS cannot be used as the root File System.
 //
